From 6e829c8da8a20437d381028de0933d910e0197d0 Mon Sep 17 00:00:00 2001
From: thomas <th.arnold@gmx.net>
Date: Fri, 22 Jun 2012 09:58:37 +0200
Subject: [PATCH] 4819_01

---
 src/app/qgshighlight.cpp |   19 +++++--------------
 src/app/qgshighlight.h   |    1 +
 2 files changed, 6 insertions(+), 14 deletions(-)

diff --git a/src/app/qgshighlight.cpp b/src/app/qgshighlight.cpp
index f3baf40..cbed52a 100644
--- a/src/app/qgshighlight.cpp
+++ b/src/app/qgshighlight.cpp
@@ -19,7 +19,6 @@
 #include "qgsmaprenderer.h"
 #include "qgscoordinatetransform.h"
 #include "qgsvectorlayer.h"
-#include <QPainter>
 
 /*!
   \class QgsHighlight
@@ -93,11 +92,11 @@ void QgsHighlight::paintLine( QPainter *p, QgsPolyline line )
 
 void QgsHighlight::paintPolygon( QPainter *p, QgsPolygon polygon )
 {
-  QPolygonF poly;
+  // OddEven fill rule by default
+  QPainterPath path;
 
-  // just ring outlines, no fill
   p->setPen( mPen );
-  p->setBrush( Qt::NoBrush );
+  p->setBrush( mBrush );
 
   for ( int i = 0; i < polygon.size(); i++ )
   {
@@ -110,18 +109,10 @@ void QgsHighlight::paintPolygon( QPainter *p, QgsPolygon polygon )
 
     ring[ polygon[i].size()] = ring[ 0 ];
 
-    p->drawPolygon( ring );
-
-    if ( i == 0 )
-      poly = ring;
-    else
-      poly = poly.subtracted( ring );
+    path.addPolygon( ring );
   }
 
-  // just fill, no outline
-  p->setPen( Qt::NoPen );
-  p->setBrush( mBrush );
-  p->drawPolygon( poly );
+  p->drawPath( path );
 }
 
 /*!
diff --git a/src/app/qgshighlight.h b/src/app/qgshighlight.h
index 7c6241b..4011108 100644
--- a/src/app/qgshighlight.h
+++ b/src/app/qgshighlight.h
@@ -21,6 +21,7 @@
 #include <QList>
 #include <QPen>
 #include <QPainter>
+#include <QPainterPath>
 
 class QgsVectorLayer;
 
-- 
1.7.8.msysgit.0

